DriverParameters
Keywords: net.corda.testing.driver.DriverParameters class
Date: 2023-09-18

net.corda.testing.driver

## Class DriverParameters

- net.corda.testing.driver.DriverParameters

-     public class DriverParameters

  Builder for configuring a `driver`.

  See Also:
    `driver`

- - ### Constructor Detail

    - #### DriverParameters

          public DriverParameters(boolean isDebug,
                                  @NotNull
                                  java.nio.file.Path driverDirectory,
                                  @NotNull
                                  PortAllocation portAllocation,
                                  @NotNull
                                  PortAllocation debugPortAllocation,
                                  @NotNull
                                  java.util.Map<java.lang.String,java.lang.String> systemProperties,
                                  boolean useTestClock,
                                  boolean startNodesInProcess,
                                  boolean waitForAllNodesToFinish,
                                  @NotNull
                                  java.util.List<net.corda.testing.node.NotarySpec> notarySpecs,
                                  @NotNull
                                  java.util.List<java.lang.String> extraCordappPackagesToScan,
                                  @NotNull
                                  JmxPolicy jmxPolicy,
                                  @NotNull
                                  NetworkParameters networkParameters,
                                  @NotNull
                                  java.util.Map<java.lang.String,? extends java.lang.Object> notaryCustomOverrides,
                                  boolean inMemoryDB,
                                  @Nullable
                                  java.util.Collection<? extends net.corda.testing.node.TestCordapp> cordappsForAllNodes,
                                  @Nullable
                                  java.nio.file.Path djvmBootstrapSource,
                                  @NotNull
                                  java.util.List<? extends java.nio.file.Path> djvmCordaSource,
                                  @NotNull
                                  java.util.Map<java.lang.String,java.lang.String> environmentVariables,
                                  boolean allowHibernateToManageAppSchema,
                                  boolean premigrateH2Database,
                                  @NotNull
                                  java.time.Duration notaryHandleTimeout)

      Builder for configuring a `driver`.

      Parameters:
        `isDebug` - Indicates whether the spawned nodes should start in jdwt debug mode and have debug level logging.
        `driverDirectory` - The base directory node directories go into, defaults to "build//". The node directories themselves are "//", where legalName defaults to "-" and may be specified in `DriverDSL.startNode`.
        `portAllocation` - The port allocation strategy to use for the messaging and the web server addresses. Defaults to incremental.
        `debugPortAllocation` - The port allocation strategy to use for jvm debugging. Defaults to incremental.
        `systemProperties` - A Map of extra system properties which will be given to each new node. Defaults to empty.
        `useTestClock` - If true the test clock will be used in Node.
        `startNodesInProcess` - Provides the default behaviour of whether new nodes should start inside this process or not. Note that this may be overridden in `DriverDSL.startNode`.
        `waitForAllNodesToFinish` - If true, the nodes will not shut down automatically after executing the code in the driver DSL block. It will wait for them to be shut down externally instead.
        `notarySpecs` - The notaries advertised for this network. These nodes will be started automatically and will be available from `DriverDSL.notaryHandles`, and will be added automatically to the network parameters. Defaults to a simple validating notary.
        `extraCordappPackagesToScan` - A List of additional cordapp packages to scan for any cordapp code, e.g. contract verification code, flows and services. The calling package is automatically included in this list. If this is not desirable then use cordappsForAllNodes instead.
        `jmxPolicy` - Used to specify whether to expose JMX metrics via Jolokia HHTP/JSON.
        `networkParameters` - The network parameters to be used by all the nodes. NetworkParameters.notaries must be empty as notaries are defined by notarySpecs.
        `notaryCustomOverrides` - Extra settings that need to be passed to the notary.
        `inMemoryDB` - Whether to use in-memory H2 for new nodes rather then on-disk (the node starts quicker, however the data is not persisted between node restarts). Has no effect if node is configured in any way to use database other than H2.
        `cordappsForAllNodes` - `class TestCordapp`s that will be added to each node started by the `interface DriverDSL`.
        `djvmBootstrapSource` - Location of a JAR containing the Java APIs for the DJVM to use.
        `djvmCordaSource` - Locations of JARs of user-supplied classes to execute within the DJVM sandbox.
        `premigrateH2Database` - Whether to use a prebuilt H2 database schema or start from an empty schema.
        `notaryHandleTimeout` - Specifies how long to wait to receive a notary handle. This waiting includes waiting forthe notary to start.This can save time for tests which do not need to migrate from a blank schema.
      See Also:
        `driver`

    - #### DriverParameters

          public DriverParameters()

      Builder for configuring a `driver`.

      See Also:
        `driver`

    - #### DriverParameters

          public DriverParameters(@NotNull
                                  java.util.Collection<? extends net.corda.testing.node.TestCordapp> cordappsForAllNodes)

    - #### DriverParameters

          public DriverParameters(boolean isDebug,
                                  @NotNull
                                  java.nio.file.Path driverDirectory,
                                  @NotNull
                                  PortAllocation portAllocation,
                                  @NotNull
                                  PortAllocation debugPortAllocation,
                                  @NotNull
                                  java.util.Map<java.lang.String,java.lang.String> systemProperties,
                                  boolean useTestClock,
                                  boolean startNodesInProcess,
                                  boolean waitForAllNodesToFinish,
                                  @NotNull
                                  java.util.List<net.corda.testing.node.NotarySpec> notarySpecs,
                                  @NotNull
                                  java.util.List<java.lang.String> extraCordappPackagesToScan,
                                  @NotNull
                                  JmxPolicy jmxPolicy,
                                  @NotNull
                                  NetworkParameters networkParameters,
                                  @NotNull
                                  java.util.Map<java.lang.String,? extends java.lang.Object> notaryCustomOverrides,
                                  boolean inMemoryDB,
                                  @Nullable
                                  java.util.Collection<? extends net.corda.testing.node.TestCordapp> cordappsForAllNodes)

    - #### DriverParameters

          public DriverParameters(boolean isDebug,
                                  @NotNull
                                  java.nio.file.Path driverDirectory,
                                  @NotNull
                                  PortAllocation portAllocation,
                                  @NotNull
                                  PortAllocation debugPortAllocation,
                                  @NotNull
                                  java.util.Map<java.lang.String,java.lang.String> systemProperties,
                                  boolean useTestClock,
                                  boolean startNodesInProcess,
                                  boolean waitForAllNodesToFinish,
                                  @NotNull
                                  java.util.List<net.corda.testing.node.NotarySpec> notarySpecs,
                                  @NotNull
                                  java.util.List<java.lang.String> extraCordappPackagesToScan,
                                  @NotNull
                                  JmxPolicy jmxPolicy,
                                  @NotNull
                                  NetworkParameters networkParameters,
                                  @NotNull
                                  java.util.Map<java.lang.String,? extends java.lang.Object> notaryCustomOverrides,
                                  boolean inMemoryDB)

    - #### DriverParameters

          public DriverParameters(boolean isDebug,
                                  @NotNull
                                  java.nio.file.Path driverDirectory,
                                  @NotNull
                                  PortAllocation portAllocation,
                                  @NotNull
                                  PortAllocation debugPortAllocation,
                                  @NotNull
                                  java.util.Map<java.lang.String,java.lang.String> systemProperties,
                                  boolean useTestClock,
                                  boolean startNodesInProcess,
                                  boolean waitForAllNodesToFinish,
                                  @NotNull
                                  java.util.List<net.corda.testing.node.NotarySpec> notarySpecs,
                                  @NotNull
                                  java.util.List<java.lang.String> extraCordappPackagesToScan,
                                  @NotNull
                                  JmxPolicy jmxPolicy,
                                  @NotNull
                                  NetworkParameters networkParameters)

    - #### DriverParameters

          public DriverParameters(boolean isDebug,
                                  @NotNull
                                  java.nio.file.Path driverDirectory,
                                  @NotNull
                                  PortAllocation portAllocation,
                                  @NotNull
                                  PortAllocation debugPortAllocation,
                                  @NotNull
                                  java.util.Map<java.lang.String,java.lang.String> systemProperties,
                                  boolean useTestClock,
                                  boolean startNodesInProcess,
                                  boolean waitForAllNodesToFinish,
                                  @NotNull
                                  java.util.List<net.corda.testing.node.NotarySpec> notarySpecs,
                                  @NotNull
                                  java.util.List<java.lang.String> extraCordappPackagesToScan,
                                  @NotNull
                                  JmxPolicy jmxPolicy,
                                  @NotNull
                                  NetworkParameters networkParameters,
                                  @NotNull
                                  java.util.Map<java.lang.String,? extends java.lang.Object> notaryCustomOverrides,
                                  boolean inMemoryDB,
                                  @Nullable
                                  java.util.Collection<? extends net.corda.testing.node.TestCordapp> cordappsForAllNodes,
                                  @Nullable
                                  java.nio.file.Path djvmBootstrapSource,
                                  @NotNull
                                  java.util.List<? extends java.nio.file.Path> djvmCordaSource,
                                  @NotNull
                                  java.util.Map<java.lang.String,java.lang.String> environmentVariables,
                                  boolean allowHibernateToManageAppSchema)

    - #### DriverParameters

          public DriverParameters(boolean isDebug,
                                  @NotNull
                                  java.nio.file.Path driverDirectory,
                                  @NotNull
                                  PortAllocation portAllocation,
                                  @NotNull
                                  PortAllocation debugPortAllocation,
                                  @NotNull
                                  java.util.Map<java.lang.String,java.lang.String> systemProperties,
                                  boolean useTestClock,
                                  boolean startNodesInProcess,
                                  boolean waitForAllNodesToFinish,
                                  @NotNull
                                  java.util.List<net.corda.testing.node.NotarySpec> notarySpecs,
                                  @NotNull
                                  java.util.List<java.lang.String> extraCordappPackagesToScan,
                                  @NotNull
                                  JmxPolicy jmxPolicy,
                                  @NotNull
                                  NetworkParameters networkParameters,
                                  boolean inMemoryDB)

    - #### DriverParameters

          public DriverParameters(boolean isDebug,
                                  @NotNull
                                  java.nio.file.Path driverDirectory,
                                  @NotNull
                                  PortAllocation portAllocation,
                                  @NotNull
                                  PortAllocation debugPortAllocation,
                                  @NotNull
                                  java.util.Map<java.lang.String,java.lang.String> systemProperties,
                                  boolean useTestClock,
                                  boolean startNodesInProcess,
                                  boolean waitForAllNodesToFinish,
                                  @NotNull
                                  java.util.List<net.corda.testing.node.NotarySpec> notarySpecs,
                                  @NotNull
                                  java.util.List<java.lang.String> extraCordappPackagesToScan,
                                  @NotNull
                                  JmxPolicy jmxPolicy,
                                  @NotNull
                                  NetworkParameters networkParameters,
                                  @NotNull
                                  java.util.Map<java.lang.String,? extends java.lang.Object> notaryCustomOverrides,
                                  boolean inMemoryDB,
                                  @Nullable
                                  java.util.Collection<? extends net.corda.testing.node.TestCordapp> cordappsForAllNodes,
                                  @Nullable
                                  java.nio.file.Path djvmBootstrapSource,
                                  @NotNull
                                  java.util.List<? extends java.nio.file.Path> djvmCordaSource,
                                  @NotNull
                                  java.util.Map<java.lang.String,java.lang.String> environmentVariables,
                                  boolean allowHibernateToManageAppSchema,
                                  boolean premigrateH2Database)

  - ### Method Detail

    - #### withIsDebug

          @NotNull
          public DriverParameters withIsDebug(boolean isDebug)

    - #### withDriverDirectory

          @NotNull
          public DriverParameters withDriverDirectory(@NotNull
                                                               java.nio.file.Path driverDirectory)

    - #### withPortAllocation

          @NotNull
          public DriverParameters withPortAllocation(@NotNull
                                                              PortAllocation portAllocation)

    - #### withDebugPortAllocation

          @NotNull
          public DriverParameters withDebugPortAllocation(@NotNull
                                                                   PortAllocation debugPortAllocation)

    - #### withSystemProperties

          @NotNull
          public DriverParameters withSystemProperties(@NotNull
                                                                java.util.Map<java.lang.String,java.lang.String> systemProperties)

    - #### withUseTestClock

          @NotNull
          public DriverParameters withUseTestClock(boolean useTestClock)

    - #### withStartNodesInProcess

          @NotNull
          public DriverParameters withStartNodesInProcess(boolean startNodesInProcess)

    - #### withWaitForAllNodesToFinish

          @NotNull
          public DriverParameters withWaitForAllNodesToFinish(boolean waitForAllNodesToFinish)

    - #### withNotarySpecs

          @NotNull
          public DriverParameters withNotarySpecs(@NotNull
                                                           java.util.List<net.corda.testing.node.NotarySpec> notarySpecs)

    - #### withExtraCordappPackagesToScan

          @Deprecated
           @NotNull
          public DriverParameters withExtraCordappPackagesToScan(@NotNull
                                                                                       java.util.List<java.lang.String> extraCordappPackagesToScan)

      Deprecated.

    - #### withJmxPolicy

          @NotNull
          public DriverParameters withJmxPolicy(@NotNull
                                                         JmxPolicy jmxPolicy)

    - #### withNetworkParameters

          @NotNull
          public DriverParameters withNetworkParameters(@NotNull
                                                                 NetworkParameters networkParameters)

    - #### withNotaryCustomOverrides

          @NotNull
          public DriverParameters withNotaryCustomOverrides(@NotNull
                                                                     java.util.Map<java.lang.String,? extends java.lang.Object> notaryCustomOverrides)

    - #### withInMemoryDB

          @NotNull
          public DriverParameters withInMemoryDB(boolean inMemoryDB)

    - #### withCordappsForAllNodes

          @NotNull
          public DriverParameters withCordappsForAllNodes(@Nullable
                                                                   java.util.Collection<? extends net.corda.testing.node.TestCordapp> cordappsForAllNodes)

    - #### withDjvmBootstrapSource

          @NotNull
          public DriverParameters withDjvmBootstrapSource(@Nullable
                                                                   java.nio.file.Path djvmBootstrapSource)

    - #### withDjvmCordaSource

          @NotNull
          public DriverParameters withDjvmCordaSource(@NotNull
                                                               java.util.List<? extends java.nio.file.Path> djvmCordaSource)

    - #### withEnvironmentVariables

          @NotNull
          public DriverParameters withEnvironmentVariables(@NotNull
                                                                    java.util.Map<java.lang.String,java.lang.String> variables)

    - #### withAllowHibernateToManageAppSchema

          @NotNull
          public DriverParameters withAllowHibernateToManageAppSchema(boolean value)

    - #### withNotaryHandleTimeout

          @NotNull
          public DriverParameters withNotaryHandleTimeout(@NotNull
                                                                   java.time.Duration value)

    - #### copy

          @NotNull
          public DriverParameters copy(boolean isDebug,
                                                @NotNull
                                                java.nio.file.Path driverDirectory,
                                                @NotNull
                                                PortAllocation portAllocation,
                                                @NotNull
                                                PortAllocation debugPortAllocation,
                                                @NotNull
                                                java.util.Map<java.lang.String,java.lang.String> systemProperties,
                                                boolean useTestClock,
                                                boolean startNodesInProcess,
                                                boolean waitForAllNodesToFinish,
                                                @NotNull
                                                java.util.List<net.corda.testing.node.NotarySpec> notarySpecs,
                                                @NotNull
                                                java.util.List<java.lang.String> extraCordappPackagesToScan,
                                                @NotNull
                                                JmxPolicy jmxPolicy,
                                                @NotNull
                                                NetworkParameters networkParameters)

    - #### copy

          @NotNull
          public DriverParameters copy(boolean isDebug,
                                                @NotNull
                                                java.nio.file.Path driverDirectory,
                                                @NotNull
                                                PortAllocation portAllocation,
                                                @NotNull
                                                PortAllocation debugPortAllocation,
                                                @NotNull
                                                java.util.Map<java.lang.String,java.lang.String> systemProperties,
                                                boolean useTestClock,
                                                boolean startNodesInProcess,
                                                boolean waitForAllNodesToFinish,
                                                @NotNull
                                                java.util.List<net.corda.testing.node.NotarySpec> notarySpecs,
                                                @NotNull
                                                java.util.List<java.lang.String> extraCordappPackagesToScan,
                                                @NotNull
                                                JmxPolicy jmxPolicy,
                                                @NotNull
                                                NetworkParameters networkParameters,
                                                @Nullable
                                                java.util.Set<? extends net.corda.testing.node.TestCordapp> cordappsForAllNodes)

    - #### copy

          @NotNull
          public DriverParameters copy(boolean isDebug,
                                                @NotNull
                                                java.nio.file.Path driverDirectory,
                                                @NotNull
                                                PortAllocation portAllocation,
                                                @NotNull
                                                PortAllocation debugPortAllocation,
                                                @NotNull
                                                java.util.Map<java.lang.String,java.lang.String> systemProperties,
                                                boolean useTestClock,
                                                boolean startNodesInProcess,
                                                boolean waitForAllNodesToFinish,
                                                @NotNull
                                                java.util.List<net.corda.testing.node.NotarySpec> notarySpecs,
                                                @NotNull
                                                java.util.List<java.lang.String> extraCordappPackagesToScan,
                                                @NotNull
                                                JmxPolicy jmxPolicy,
                                                @NotNull
                                                NetworkParameters networkParameters,
                                                @NotNull
                                                java.util.Map<java.lang.String,? extends java.lang.Object> notaryCustomOverrides,
                                                boolean inMemoryDB,
                                                @Nullable
                                                java.util.Collection<? extends net.corda.testing.node.TestCordapp> cordappsForAllNodes)

    - #### copy

          @NotNull
          public DriverParameters copy(boolean isDebug,
                                                @NotNull
                                                java.nio.file.Path driverDirectory,
                                                @NotNull
                                                PortAllocation portAllocation,
                                                @NotNull
                                                PortAllocation debugPortAllocation,
                                                @NotNull
                                                java.util.Map<java.lang.String,java.lang.String> systemProperties,
                                                boolean useTestClock,
                                                boolean startNodesInProcess,
                                                boolean waitForAllNodesToFinish,
                                                @NotNull
                                                java.util.List<net.corda.testing.node.NotarySpec> notarySpecs,
                                                @NotNull
                                                java.util.List<java.lang.String> extraCordappPackagesToScan,
                                                @NotNull
                                                JmxPolicy jmxPolicy,
                                                @NotNull
                                                NetworkParameters networkParameters,
                                                @NotNull
                                                java.util.Map<java.lang.String,? extends java.lang.Object> notaryCustomOverrides,
                                                boolean inMemoryDB,
                                                @Nullable
                                                java.util.Collection<? extends net.corda.testing.node.TestCordapp> cordappsForAllNodes,
                                                @Nullable
                                                java.nio.file.Path djvmBootstrapSource,
                                                @NotNull
                                                java.util.List<? extends java.nio.file.Path> djvmCordaSource,
                                                @NotNull
                                                java.util.Map<java.lang.String,java.lang.String> environmentVariables,
                                                boolean allowHibernateToManageAppSchema)

    - #### copy

          @NotNull
          public DriverParameters copy(boolean isDebug,
                                                @NotNull
                                                java.nio.file.Path driverDirectory,
                                                @NotNull
                                                PortAllocation portAllocation,
                                                @NotNull
                                                PortAllocation debugPortAllocation,
                                                @NotNull
                                                java.util.Map<java.lang.String,java.lang.String> systemProperties,
                                                boolean useTestClock,
                                                boolean startNodesInProcess,
                                                boolean waitForAllNodesToFinish,
                                                @NotNull
                                                java.util.List<net.corda.testing.node.NotarySpec> notarySpecs,
                                                @NotNull
                                                java.util.List<java.lang.String> extraCordappPackagesToScan,
                                                @NotNull
                                                JmxPolicy jmxPolicy,
                                                @NotNull
                                                NetworkParameters networkParameters,
                                                @NotNull
                                                java.util.Map<java.lang.String,? extends java.lang.Object> notaryCustomOverrides,
                                                boolean inMemoryDB,
                                                @Nullable
                                                java.util.Collection<? extends net.corda.testing.node.TestCordapp> cordappsForAllNodes,
                                                @Nullable
                                                java.nio.file.Path djvmBootstrapSource,
                                                @NotNull
                                                java.util.List<? extends java.nio.file.Path> djvmCordaSource,
                                                @NotNull
                                                java.util.Map<java.lang.String,java.lang.String> environmentVariables,
                                                boolean allowHibernateToManageAppSchema,
                                                boolean premigrateH2Database)

    - #### isDebug

          public boolean isDebug()

      Indicates whether the spawned nodes should start in jdwt debug mode and have debug level logging.

    - #### getDriverDirectory

          @NotNull
          public java.nio.file.Path getDriverDirectory()

      The base directory node directories go into,

      defaults to "build//". The node directories themselves are "//", where legalName defaults to "-" and may be specified in `DriverDSL.startNode`.

      See Also:
        `DriverDSL.startNode`

    - #### getPortAllocation

          @NotNull
          public PortAllocation getPortAllocation()

      The port allocation strategy to use for the messaging and the web server addresses.

      Defaults to incremental.

    - #### getDebugPortAllocation

          @NotNull
          public PortAllocation getDebugPortAllocation()

      The port allocation strategy to use for jvm debugging.

      Defaults to incremental.

    - #### getSystemProperties

          @NotNull
          public java.util.Map<java.lang.String,java.lang.String> getSystemProperties()

      A Map of extra system properties which will be given to each new node.

      Defaults to empty.

    - #### getUseTestClock

          public boolean getUseTestClock()

      If true the test clock will be used in Node.

    - #### getStartNodesInProcess

          public boolean getStartNodesInProcess()

      Provides the default behaviour of whether new nodes should start inside this process or

      not. Note that this may be overridden in `DriverDSL.startNode`.

      See Also:
        `DriverDSL.startNode`

    - #### getWaitForAllNodesToFinish

          public boolean getWaitForAllNodesToFinish()

      If true,

      the nodes will not shut down automatically after executing the code in the driver DSL block. It will wait for them to be shut down externally instead.

    - #### getNotarySpecs

          @NotNull
          public java.util.List<net.corda.testing.node.NotarySpec> getNotarySpecs()

      The notaries advertised for this network.

      These nodes will be started automatically and will be available from `DriverDSL.notaryHandles`, and will be added automatically to the network parameters. Defaults to a simple validating notary.

      See Also:
        `DriverDSL.notaryHandles`

    - #### getExtraCordappPackagesToScan

          @NotNull
          public java.util.List<java.lang.String> getExtraCordappPackagesToScan()

      Deprecated.

      A

      List of additional cordapp packages to scan for any cordapp code, e.g. contract verification code, flows and services. The calling package is automatically included in this list. If this is not desirable then use cordappsForAllNodes instead.

      See Also:
        List

    - #### getJmxPolicy

          @NotNull
          public JmxPolicy getJmxPolicy()

      Used to specify whether to expose JMX metrics via Jolokia HHTP/JSON.

    - #### getNetworkParameters

          @NotNull
          public NetworkParameters getNetworkParameters()

      The network parameters to be used by all the nodes.

      NetworkParameters.notaries must be empty as notaries are defined by notarySpecs.

    - #### getNotaryCustomOverrides

          @NotNull
          public java.util.Map<java.lang.String,java.lang.Object> getNotaryCustomOverrides()

      Extra settings that need to be passed to the notary.

    - #### getInMemoryDB

          public boolean getInMemoryDB()

      Whether to use in-memory H2 for new nodes rather then on-disk

      (the node starts quicker, however the data is not persisted between node restarts). Has no effect if node is configured in any way to use database other than H2.

    - #### getCordappsForAllNodes

          @Nullable
          public java.util.Collection<net.corda.testing.node.TestCordapp> getCordappsForAllNodes()

      `class TestCordapp`

      s that will be added to each node started by the `interface DriverDSL`.

      See Also:
        `class TestCordapp`, `interface DriverDSL`

    - #### getDjvmBootstrapSource

          @Nullable
          public java.nio.file.Path getDjvmBootstrapSource()

      Location of a JAR containing the Java APIs for the DJVM to use.

    - #### getDjvmCordaSource

          @NotNull
          public java.util.List<java.nio.file.Path> getDjvmCordaSource()

      Locations of JARs of user-supplied classes to execute within the DJVM sandbox.

    - #### getEnvironmentVariables

          @NotNull
          public java.util.Map<java.lang.String,java.lang.String> getEnvironmentVariables()

    - #### getAllowHibernateToManageAppSchema

          public boolean getAllowHibernateToManageAppSchema()

    - #### getPremigrateH2Database

          public boolean getPremigrateH2Database()

      Whether to use a prebuilt H2 database schema or start from an empty schema.

    - #### getNotaryHandleTimeout

          @NotNull
          public java.time.Duration getNotaryHandleTimeout()

      Specifies how long to wait to receive a notary handle.

      This waiting includes waiting forthe notary to start.This can save time for tests which do not need to migrate from a blank schema.

    - #### component1

          public boolean component1()

      Indicates whether the spawned nodes should start in jdwt debug mode and have debug level logging.

    - #### component2

          @NotNull
          public java.nio.file.Path component2()

      The base directory node directories go into,

      defaults to "build//". The node directories themselves are "//", where legalName defaults to "-" and may be specified in `DriverDSL.startNode`.

      See Also:
        `DriverDSL.startNode`

    - #### component3

          @NotNull
          public PortAllocation component3()

      The port allocation strategy to use for the messaging and the web server addresses.

      Defaults to incremental.

    - #### component4

          @NotNull
          public PortAllocation component4()

      The port allocation strategy to use for jvm debugging.

      Defaults to incremental.

    - #### component5

          @NotNull
          public java.util.Map<java.lang.String,java.lang.String> component5()

      A Map of extra system properties which will be given to each new node.

      Defaults to empty.

    - #### component6

          public boolean component6()

      If true the test clock will be used in Node.

    - #### component7

          public boolean component7()

      Provides the default behaviour of whether new nodes should start inside this process or

      not. Note that this may be overridden in `DriverDSL.startNode`.

      See Also:
        `DriverDSL.startNode`

    - #### component8

          public boolean component8()

      If true,

      the nodes will not shut down automatically after executing the code in the driver DSL block. It will wait for them to be shut down externally instead.

    - #### component9

          @NotNull
          public java.util.List<net.corda.testing.node.NotarySpec> component9()

      The notaries advertised for this network.

      These nodes will be started automatically and will be available from `DriverDSL.notaryHandles`, and will be added automatically to the network parameters. Defaults to a simple validating notary.

      See Also:
        `DriverDSL.notaryHandles`

    - #### component10

          @NotNull
          public java.util.List<java.lang.String> component10()

      A

      List of additional cordapp packages to scan for any cordapp code, e.g. contract verification code, flows and services. The calling package is automatically included in this list. If this is not desirable then use cordappsForAllNodes instead.

      See Also:
        List

    - #### component11

          @NotNull
          public JmxPolicy component11()

      Used to specify whether to expose JMX metrics via Jolokia HHTP/JSON.

    - #### component12

          @NotNull
          public NetworkParameters component12()

      The network parameters to be used by all the nodes.

      NetworkParameters.notaries must be empty as notaries are defined by notarySpecs.

    - #### component13

          @NotNull
          public java.util.Map<java.lang.String,java.lang.Object> component13()

      Extra settings that need to be passed to the notary.

    - #### component14

          public boolean component14()

      Whether to use in-memory H2 for new nodes rather then on-disk

      (the node starts quicker, however the data is not persisted between node restarts). Has no effect if node is configured in any way to use database other than H2.

    - #### component15

          @Nullable
          public java.util.Collection<net.corda.testing.node.TestCordapp> component15()

      `class TestCordapp`

      s that will be added to each node started by the `interface DriverDSL`.

      See Also:
        `class TestCordapp`, `interface DriverDSL`

    - #### component16

          @Nullable
          public java.nio.file.Path component16()

      Location of a JAR containing the Java APIs for the DJVM to use.

    - #### component17

          @NotNull
          public java.util.List<java.nio.file.Path> component17()

      Locations of JARs of user-supplied classes to execute within the DJVM sandbox.

    - #### component18

          @NotNull
          public java.util.Map<java.lang.String,java.lang.String> component18()

    - #### component19

          public boolean component19()

    - #### component20

          public boolean component20()

      Whether to use a prebuilt H2 database schema or start from an empty schema.

    - #### component21

          @NotNull
          public java.time.Duration component21()

      Specifies how long to wait to receive a notary handle.

      This waiting includes waiting forthe notary to start.This can save time for tests which do not need to migrate from a blank schema.

    - #### copy

          @NotNull
          public DriverParameters copy(boolean isDebug,
                                                @NotNull
                                                java.nio.file.Path driverDirectory,
                                                @NotNull
                                                PortAllocation portAllocation,
                                                @NotNull
                                                PortAllocation debugPortAllocation,
                                                @NotNull
                                                java.util.Map<java.lang.String,java.lang.String> systemProperties,
                                                boolean useTestClock,
                                                boolean startNodesInProcess,
                                                boolean waitForAllNodesToFinish,
                                                @NotNull
                                                java.util.List<net.corda.testing.node.NotarySpec> notarySpecs,
                                                @NotNull
                                                java.util.List<java.lang.String> extraCordappPackagesToScan,
                                                @NotNull
                                                JmxPolicy jmxPolicy,
                                                @NotNull
                                                NetworkParameters networkParameters,
                                                @NotNull
                                                java.util.Map<java.lang.String,? extends java.lang.Object> notaryCustomOverrides,
                                                boolean inMemoryDB,
                                                @Nullable
                                                java.util.Collection<? extends net.corda.testing.node.TestCordapp> cordappsForAllNodes,
                                                @Nullable
                                                java.nio.file.Path djvmBootstrapSource,
                                                @NotNull
                                                java.util.List<? extends java.nio.file.Path> djvmCordaSource,
                                                @NotNull
                                                java.util.Map<java.lang.String,java.lang.String> environmentVariables,
                                                boolean allowHibernateToManageAppSchema,
                                                boolean premigrateH2Database,
                                                @NotNull
                                                java.time.Duration notaryHandleTimeout)

      Builder for configuring a `driver`.

      See Also:
        `driver`

    - #### toString

          @NotNull
          public java.lang.String toString()

      Builder for configuring a `driver`.

      See Also:
        `driver`

    - #### hashCode

          public int hashCode()

      Builder for configuring a `driver`.

      See Also:
        `driver`

    - #### equals

          public boolean equals(@Nullable
                                java.lang.Object p)

      Builder for configuring a `driver`.

      See Also:
        `driver`